#include "stdafx.h"
#include "resource.h"

#include "..\VertDrawSrc\VertDraw.h"

#define MAX_LOADSTRING 100


HINSTANCE hInst;
TCHAR szTitle[MAX_LOADSTRING];
TCHAR szWindowClass[MAX_LOADSTRING];
TCHAR szString[MAX_LOADSTRING];
UINT  uXspace,uYspace;

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	EnterString(HWND, UINT, WPARAM, LPARAM);
UINT				GetMenuChoice(HMENU, UINT, UINT*);

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	MSG msg;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_DEMO, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}

ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_DEMO);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_DEMO;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(	szWindowClass, 
						szTitle, 
						WS_OVERLAPPEDWINDOW,
						(GetSystemMetrics(SM_CXFULLSCREEN)/2) - (640/2), 
						(GetSystemMetrics(SM_CYFULLSCREEN)/2) - (480/2), 
						640, 
						480, 
						NULL, 
						NULL, 
						hInstance, 
						NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}


LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int					lfheight;
	PAINTSTRUCT			ps;
	HDC					hdc;
	RECT				rt;
	static UINT			uDrawFlags = DV_CENTERALL|DV_TEXTCENTER;

	// Variables for the ChooseFont
	CHOOSEFONT cf;
	static LOGFONT lf;
	static DWORD rgbCurrent;
	static HFONT hfont=0, hfontPrev;

	switch (message) 
	{		
		case WM_CREATE:
			uXspace = 20;
			uYspace = 3;
			GetMenuChoice(GetMenu(hwnd),0,&uDrawFlags);
			LoadString(hInst, IDS_DEMO, szString, MAX_LOADSTRING);
			hdc = GetDC(hwnd);
			rgbCurrent = RGB(255,0,0);
			lfheight = -MulDiv(36, GetDeviceCaps(hdc, LOGPIXELSY), 72);
			hfont = CreateFont(lfheight, 0, 0, 0, 700, FALSE, 0, 0, 0, 0, 0, 0, 0, _T("La Bamba LET") );
			GetObject(hfont,sizeof(LOGFONT),&lf);
			ReleaseDC(hwnd,hdc);
		break;

		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDM_ABOUT:
				    DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hwnd, (DLGPROC)About);
				    break;
				case IDM_EXIT:
				    DestroyWindow(hwnd);
				    break;
				case IDM_FONT:
					ZeroMemory(&cf, sizeof(cf));
					cf.lStructSize	= sizeof (cf);
					cf.hwndOwner	= hwnd;
					cf.lpLogFont	= &lf;
					cf.rgbColors	= rgbCurrent;
					cf.Flags		= CF_SCREENFONTS | CF_EFFECTS | CF_INITTOLOGFONTSTRUCT ;

					if (ChooseFont(&cf)==TRUE) {
						hfont		= CreateFontIndirect(cf.lpLogFont);
						rgbCurrent	= cf.rgbColors;
						InvalidateRect(hwnd,0,1);
					}
					break;
				case IDM_INPUT:
					if (DialogBox(hInst, (LPCTSTR)IDD_INPUT, hwnd, (DLGPROC)EnterString))
						szString;
						InvalidateRect(hwnd,0,1);
					break;

				case IDM_CALCRECT:
					{
						TCHAR str[128];
						GetClientRect(hwnd,&rt);
						hdc = GetDC(hwnd);
						DrawVertText(hdc, szString, _tcslen(szString), &rt, uDrawFlags|DV_CALCRECT);
						ReleaseDC(hwnd,hdc);
						_stprintf(str,_T("DrawVertText() Return a rect of:\n\n\tTop:\t%d\n\tBottom:\t%d\n\tLeft:\t%d\n\tRight:\t%d."),
							rt.top,
							rt.bottom,
							rt.left,
							rt.right);
						MessageBox(hwnd,str,_T("DV_CALCRECT"),0);
					}
					break;

				case IDM_HCENTER:
				case IDM_RIGHT:
				case IDM_VCENTER:
				case IDM_BOTTOM:
				case IDM_CENTERALL:
				case IDM_TEXTTOP:
				case IDM_TEXTCENTER:
				case IDM_TEXTBOTTOM:
				case IDM_TEXTJUSTIFY:
				case IDM_DOUBLEBUFFER:
					GetMenuChoice(GetMenu(hwnd),LOWORD(wParam),&uDrawFlags);
					InvalidateRect(hwnd,0,TRUE);
					break;

				default:
				   return DefWindowProc(hwnd, message, wParam, lParam);
			}
		break;

		case WM_PAINT:
			hdc = BeginPaint(hwnd, &ps);

			hfontPrev = (HFONT)SelectObject(hdc, hfont);
			SetTextColor(hdc, rgbCurrent);

			GetClientRect(hwnd, &rt);

			DrawVertText(hdc, szString, _tcslen(szString), &rt, uDrawFlags,uXspace,uYspace);

			hfont = (HFONT)SelectObject(hdc, hfontPrev);
			DeleteObject(hfontPrev);

			EndPaint(hwnd, &ps);
		break;

		case WM_DESTROY:
			PostQuitMessage(0);
		break;

		default:
			return DefWindowProc(hwnd, message, wParam, lParam);
   }
   return 0;
}

LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

LRESULT CALLBACK EnterString(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	TCHAR szBuf[MAX_LOADSTRING];
	TCHAR *tmp;
	TCHAR *idx;

	switch (message)
	{
		case WM_INITDIALOG:
			memset(szBuf,0,MAX_LOADSTRING);
			tmp = szString;
			while (idx != NULL) {
				idx = _tcsstr(tmp,_T("\n"));
				_tcsncat(szBuf,tmp,idx-tmp);
				if (idx != 0) {
					_tcscat(szBuf,_T("\\n"));
					tmp = idx;
					tmp = _tcsinc(tmp);
				}
			}
			SendMessage(GetDlgItem(hDlg,IDC_HORNUM),EM_LIMITTEXT,2,0);
			SendMessage(GetDlgItem(hDlg,IDC_VERTNUM),EM_LIMITTEXT,2,0);
			SendMessage(GetDlgItem(hDlg,IDC_EDIT),EM_LIMITTEXT,MAX_LOADSTRING,0);
			SendMessage(GetDlgItem(hDlg,IDC_EDIT),WM_SETTEXT,0,(LONG)szBuf);
			return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK) {
				memset(szBuf,0,MAX_LOADSTRING);
				szBuf[0] = MAX_LOADSTRING;
				int len = SendMessage(GetDlgItem(hDlg,IDC_EDIT),EM_GETLINE,0,(LONG)szBuf);
				if (len <= 0) {
					EndDialog(hDlg,0);
					return FALSE;
				}
				memset(szString,0,MAX_LOADSTRING);
				tmp = szBuf;
				while (idx != NULL) {
					idx = _tcsstr(tmp,_T("\\n"));
					_tcsncat(szString,tmp,idx-tmp);
					if (idx != 0) {
						_tcscat(szString,_T("\n"));
						tmp = idx;
						tmp = _tcsinc(tmp);
						tmp = _tcsinc(tmp);
					}
				}

				memset(szBuf,0,MAX_LOADSTRING);
				szBuf[0] = MAX_LOADSTRING;
				len = SendMessage(GetDlgItem(hDlg,IDC_HORNUM),EM_GETLINE,0,(LONG)szBuf);
				if (len > 0)
					uXspace = _ttoi(szBuf);

				memset(szBuf,0,MAX_LOADSTRING);
				szBuf[0] = MAX_LOADSTRING;
				len = SendMessage(GetDlgItem(hDlg,IDC_VERTNUM),EM_GETLINE,0,(LONG)szBuf);
				if (len > 0)
					uYspace = _ttoi(szBuf);

				EndDialog(hDlg, 1);
				return TRUE;
			}
			if (LOWORD(wParam) == IDCANCEL) {
				EndDialog(hDlg, 0);
				return TRUE;
			}
			break;
	}
    return FALSE;
}

UINT GetMenuChoice(HMENU hMenu, UINT uControl, UINT *lpFlags) 
{
	UINT uMenuState;
	UINT uRetVal = *lpFlags;

	switch (uControl) {
		case IDM_HCENTER:
			uMenuState = GetMenuState(hMenu,IDM_HCENTER,MF_BYCOMMAND);
			if (uMenuState == MF_UNCHECKED) {
				CheckMenuItem(hMenu,IDM_RIGHT,		MF_UNCHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_CENTERALL,	MF_UNCHECKED|MF_BYCOMMAND);

				uMenuState = (uRetVal | DV_VCENTER) == uRetVal ? MF_CHECKED : MF_UNCHECKED;
				CheckMenuItem(hMenu,IDM_VCENTER,uMenuState|MF_BYCOMMAND);

				uMenuState = MF_CHECKED;

				uRetVal |= DV_HCENTER;
				uRetVal = uRetVal & ~DV_RIGHT;
			}
			else {
				CheckMenuItem(hMenu,IDM_CENTERALL,	MF_UNCHECKED|MF_BYCOMMAND);
				uRetVal ^= DV_HCENTER;
				uMenuState = MF_UNCHECKED;
			}						
			CheckMenuItem(hMenu,IDM_HCENTER,uMenuState|MF_BYCOMMAND);
			break;

		case IDM_RIGHT:
			uMenuState = GetMenuState(hMenu,IDM_RIGHT,MF_BYCOMMAND);
			if (uMenuState == MF_UNCHECKED) {
				CheckMenuItem(hMenu,IDM_HCENTER,	MF_UNCHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_CENTERALL,	MF_UNCHECKED|MF_BYCOMMAND);

				uMenuState = (uRetVal | DV_VCENTER) == uRetVal ? MF_CHECKED : MF_UNCHECKED;
				CheckMenuItem(hMenu,IDM_VCENTER,uMenuState|MF_BYCOMMAND);

				uMenuState = MF_CHECKED;

				uRetVal |= DV_RIGHT;
				uRetVal = uRetVal & ~DV_HCENTER;
			}
			else {
				uRetVal ^= DV_RIGHT;
				uMenuState = MF_UNCHECKED;
			}					
			CheckMenuItem(hMenu,IDM_RIGHT,uMenuState|MF_BYCOMMAND);
			break;

		case IDM_VCENTER:
			uMenuState = GetMenuState(hMenu,IDM_VCENTER,MF_BYCOMMAND);
			if (uMenuState == MF_UNCHECKED) {
				CheckMenuItem(hMenu,IDM_BOTTOM,		MF_UNCHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_CENTERALL,	MF_UNCHECKED|MF_BYCOMMAND);

				uMenuState = (uRetVal | DV_HCENTER) == uRetVal ? MF_CHECKED : MF_UNCHECKED;
				CheckMenuItem(hMenu,IDM_HCENTER,uMenuState|MF_BYCOMMAND);

				uMenuState = MF_CHECKED;

				uRetVal |= DV_VCENTER;
				uRetVal = uRetVal & ~DV_BOTTOM;
			}
			else {
				CheckMenuItem(hMenu,IDM_CENTERALL,	MF_UNCHECKED|MF_BYCOMMAND);
				uRetVal ^= DV_VCENTER;
				uMenuState = MF_UNCHECKED;
			}						
			CheckMenuItem(hMenu,IDM_VCENTER,uMenuState|MF_BYCOMMAND);
			break;

		case IDM_BOTTOM:
			uMenuState = GetMenuState(hMenu,IDM_BOTTOM,MF_BYCOMMAND);
			if (uMenuState == MF_UNCHECKED) {
				CheckMenuItem(hMenu,IDM_VCENTER,	MF_UNCHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_CENTERALL,	MF_UNCHECKED|MF_BYCOMMAND);

				uMenuState = (uRetVal | DV_HCENTER) == uRetVal ? MF_CHECKED : MF_UNCHECKED;
				CheckMenuItem(hMenu,IDM_HCENTER,uMenuState|MF_BYCOMMAND);

				uMenuState = MF_CHECKED;

				uRetVal |= DV_BOTTOM;
				uRetVal ^= (uRetVal | DV_VCENTER) == uRetVal ? DV_VCENTER : 0;
				uRetVal = uRetVal & ~DV_VCENTER;
			}
			else {
				uRetVal ^= DV_BOTTOM;
				uMenuState = MF_UNCHECKED;
			}						
			CheckMenuItem(hMenu,IDM_BOTTOM,uMenuState|MF_BYCOMMAND);
			break;

		case IDM_CENTERALL:
			uMenuState = GetMenuState(hMenu,IDM_CENTERALL,MF_BYCOMMAND);
			if (uMenuState == MF_UNCHECKED) {
				CheckMenuItem(hMenu,IDM_HCENTER,	MF_CHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_RIGHT,		MF_UNCHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_VCENTER,	MF_CHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_BOTTOM,		MF_UNCHECKED|MF_BYCOMMAND);

				uMenuState = MF_CHECKED;

				uRetVal |= DV_CENTERALL;
				uRetVal = uRetVal & ~DV_RIGHT;
				uRetVal = uRetVal & ~DV_BOTTOM;
			}
			else {
				CheckMenuItem(hMenu,IDM_VCENTER,	MF_UNCHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_HCENTER,	MF_UNCHECKED|MF_BYCOMMAND);
				uRetVal ^= DV_CENTERALL;
				uMenuState = MF_UNCHECKED;
			}
			CheckMenuItem(hMenu,IDM_CENTERALL,uMenuState|MF_BYCOMMAND);
			break;

		case IDM_TEXTTOP:
			uMenuState = GetMenuState(hMenu,IDM_TEXTTOP,MF_BYCOMMAND);
			if (uMenuState == MF_UNCHECKED) {
				CheckMenuItem(hMenu,IDM_TEXTCENTER,	MF_UNCHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_TEXTBOTTOM,	MF_UNCHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_TEXTJUSTIFY,MF_UNCHECKED|MF_BYCOMMAND);

				uMenuState = MF_CHECKED;

				uRetVal |= DV_TEXTTOP;
				uRetVal = uRetVal & ~DV_TEXTBOTTOM;
				uRetVal = uRetVal & ~DV_TEXTCENTER;
				uRetVal = uRetVal & ~DV_TEXTJUSTIFY;
			}
			else {
				uRetVal ^= DV_TEXTTOP;
				uMenuState = MF_UNCHECKED;
			}						
			CheckMenuItem(hMenu,IDM_TEXTTOP,uMenuState|MF_BYCOMMAND);
			break;

		case IDM_TEXTCENTER:
			uMenuState = GetMenuState(hMenu,IDM_TEXTCENTER,MF_BYCOMMAND);
			if (uMenuState == MF_UNCHECKED) {
				CheckMenuItem(hMenu,IDM_TEXTTOP,	MF_UNCHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_TEXTBOTTOM,	MF_UNCHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_TEXTJUSTIFY,MF_UNCHECKED|MF_BYCOMMAND);

				uMenuState = MF_CHECKED;

				uRetVal |= DV_TEXTCENTER;
				uRetVal = uRetVal & ~DV_TEXTTOP;
				uRetVal = uRetVal & ~DV_TEXTBOTTOM;
				uRetVal = uRetVal & ~DV_TEXTJUSTIFY;
			}
			else {
				uRetVal ^= DV_TEXTCENTER;
				uMenuState = MF_UNCHECKED;
			}					
			CheckMenuItem(hMenu,IDM_TEXTCENTER,uMenuState|MF_BYCOMMAND);
			break;

		case IDM_TEXTBOTTOM:
			uMenuState = GetMenuState(hMenu,IDM_TEXTBOTTOM,MF_BYCOMMAND);
			if (uMenuState == MF_UNCHECKED) {
				CheckMenuItem(hMenu,IDM_TEXTTOP,	MF_UNCHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_TEXTCENTER,	MF_UNCHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_TEXTJUSTIFY,MF_UNCHECKED|MF_BYCOMMAND);

				uMenuState = MF_CHECKED;

				uRetVal |= DV_TEXTBOTTOM;
				uRetVal = uRetVal & ~DV_TEXTTOP;
				uRetVal = uRetVal & ~DV_TEXTCENTER;
				uRetVal = uRetVal & ~DV_TEXTJUSTIFY;
			}
			else {
				uRetVal ^= DV_TEXTBOTTOM;
				uMenuState = MF_UNCHECKED;
			}						
			CheckMenuItem(hMenu,IDM_TEXTBOTTOM,uMenuState|MF_BYCOMMAND);
			break;

		case IDM_TEXTJUSTIFY:
			uMenuState = GetMenuState(hMenu,IDM_TEXTJUSTIFY,MF_BYCOMMAND);
			if (uMenuState == MF_UNCHECKED) {
				CheckMenuItem(hMenu,IDM_TEXTTOP,	MF_UNCHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_TEXTCENTER,	MF_UNCHECKED|MF_BYCOMMAND);
				CheckMenuItem(hMenu,IDM_TEXTBOTTOM,	MF_UNCHECKED|MF_BYCOMMAND);

				uMenuState = MF_CHECKED;

				uRetVal |= DV_TEXTJUSTIFY;
				uRetVal = uRetVal & ~DV_TEXTTOP;
				uRetVal = uRetVal & ~DV_TEXTCENTER;
				uRetVal = uRetVal & ~DV_TEXTBOTTOM;
			}
			else {
				uRetVal ^= DV_TEXTJUSTIFY;
				uMenuState = MF_UNCHECKED;
			}						
			CheckMenuItem(hMenu,IDM_TEXTJUSTIFY,uMenuState|MF_BYCOMMAND);
			break;

		case IDM_DOUBLEBUFFER:
			uMenuState = GetMenuState(hMenu,IDM_DOUBLEBUFFER,MF_BYCOMMAND);
			if (uMenuState == MF_UNCHECKED) {
				CheckMenuItem(hMenu,IDM_DOUBLEBUFFER,	MF_UNCHECKED|MF_BYCOMMAND);
				uMenuState = MF_CHECKED;
				uRetVal |= DV_DOUBLEBUFFER;
			}
			else {
				uRetVal ^= DV_DOUBLEBUFFER;				
				uMenuState = MF_UNCHECKED;
			}						
			CheckMenuItem(hMenu,IDM_DOUBLEBUFFER,uMenuState|MF_BYCOMMAND);
			break;

		default:
			if ((uRetVal & DV_HCENTER)	== DV_HCENTER)
				CheckMenuItem(hMenu,	IDM_HCENTER,	MF_CHECKED|MF_BYCOMMAND);
			if ((uRetVal & DV_RIGHT)	== DV_RIGHT)
				CheckMenuItem(hMenu,	IDM_RIGHT,		MF_CHECKED|MF_BYCOMMAND);
			if ((uRetVal & DV_VCENTER)	== DV_VCENTER)
				CheckMenuItem(hMenu,	IDM_VCENTER,	MF_CHECKED|MF_BYCOMMAND);
			if ((uRetVal & DV_BOTTOM)	== DV_BOTTOM)
				CheckMenuItem(hMenu,	IDM_BOTTOM,		MF_CHECKED|MF_BYCOMMAND);
			if ((uRetVal & DV_VCENTER)	== DV_VCENTER)
				CheckMenuItem(hMenu,	IDM_VCENTER,	MF_CHECKED|MF_BYCOMMAND);
			if ((uRetVal & DV_TEXTTOP)	== DV_TEXTTOP)
				CheckMenuItem(hMenu,	IDM_TEXTTOP,	MF_CHECKED|MF_BYCOMMAND);
			if ((uRetVal & DV_TEXTCENTER)	== DV_TEXTCENTER)
				CheckMenuItem(hMenu,	IDM_TEXTCENTER,	MF_CHECKED|MF_BYCOMMAND);
			if ((uRetVal & DV_TEXTBOTTOM)	== DV_TEXTBOTTOM)
				CheckMenuItem(hMenu,	IDM_TEXTBOTTOM,	MF_CHECKED|MF_BYCOMMAND);
			if ((uRetVal & DV_TEXTJUSTIFY)	== DV_TEXTJUSTIFY)
				CheckMenuItem(hMenu,	IDM_TEXTJUSTIFY,MF_CHECKED|MF_BYCOMMAND);
			if ((uRetVal & DV_DOUBLEBUFFER)	== DV_DOUBLEBUFFER)
				CheckMenuItem(hMenu,	IDM_DOUBLEBUFFER,MF_CHECKED|MF_BYCOMMAND);
			break;
	}

	UINT uHState = GetMenuState(hMenu,IDM_HCENTER,MF_BYCOMMAND);
	UINT uVState = GetMenuState(hMenu,IDM_VCENTER,MF_BYCOMMAND);
	if ((uVState == MF_CHECKED) && (uHState == MF_CHECKED))
		CheckMenuItem(hMenu,IDM_CENTERALL,MF_CHECKED|MF_BYCOMMAND);

	return *lpFlags = uRetVal;
}
